plugins {
    kotlin("jvm") version "2.0.10"
    id("java")
    id("com.github.johnrengelman.shadow") version "8.1.1"
}

group = "io.github.thehrz.allmusicreload"
version = "1.0.0"

repositories {
    mavenCentral()
    maven("https://hub.spigotmc.org/nexus/content/groups/public")
    maven("https://repo.extendedclip.com/content/repositories/placeholderapi/")
    maven("https://jitpack.io")
    maven(" https://mvnrepository.com/artifact/mysql/mysql-connector-java")
    maven("https://maven.citizensnpcs.co/repo")
    maven("https://nexus.velocitypowered.com/repository/maven-public/")
}

dependencies {
    compileOnly("net.md-5:bungeecord-api:1.20-R0.1-SNAPSHOT")
    compileOnly("com.github.MilkBowl:VaultAPI:1.7.1")
    compileOnly("com.velocitypowered:velocity-api:3.0.0")
    compileOnly("me.clip:placeholderapi:2.11.6")
    implementation("org.xerial:sqlite-jdbc:3.46.0.1")
    api("com.squareup.okhttp3:okhttp:4.12.0")
    api("com.google.code.gson:gson:2.11.0")
    annotationProcessor("com.velocitypowered:velocity-api:3.0.0")
}

val targetJavaVersion = 17
kotlin {
    jvmToolchain(targetJavaVersion)
}

tasks.shadowJar {
    exclude("kotlin/**")
}

tasks.build {
    dependsOn("shadowJar")
}